C : --------------------------------------------------------------------
C : ####################################################################
C : #                                                                  #
C : #     Design -Programm : idm.prg                                   #
C : #                                                                  #
C : #     Zweck            : Item-Info fuer Layout ermitteln           #
C : #                                                                  #
C : #     Einsatz fuer     : I-DEAS- Master Series 3                   #
C : #                                                                  #
C : #     Version          : 1.0.0                                     #
C : #                                                                  #
C : #     Historie         : 26.07.1996 bittecri  Neuerstellung        #
C : #                        14.10.1996 bittecri  Aenderung            #
C : #                                                                  #
C : ####################################################################
C : #                                                                  #
C : # Kurzbeschreibung                                                 #
C : # ================                                                 #
C : #                                                                  #
C : # Script zur Ermittlung der Herkunftsinformationen des Layouts,    #
C : # welches nach VE uebertragen werden soll.                         #
C : # Die Informationen (Layout_name, Partnummer und Version) werden   #
C : # mittels Report-Funktion in das ASCII-File "idminfo.3d2d"         #
C : # geschrieben!                                                     #
C : # Achtung: Das Script funktioniert z.Zt. nur fuer I-DEAS-Language: #
C : #          -english                                                #
C : #          -german                                                 #
C : #                                                                  #
C : ####################################################################
C : --------------------------------------------------------------------
C :
K : #echo none
K :
K : #output "********************************************************"
K : #output "***** Ermittlung der Layoutinformationen****************"
C :
K : $ mpos :
C : __________________________________________________________________
C :
C : Grafik loeschen
K : CG
C : ---------------------------------------
C : **** Forms abschalten
K : /O P P 2 D FD OF Okay Okay
C : ---------------------------------------
C : **** Fehlermeldung fuer COUNTS in Formblaettern abschalten
C :
K : /O P P 8 ;
K : WA OF
K : Okay Okay
C : __________________________________________________________________
C :
K : #DELETE all
C :
C : -----------------------------------------------
C : Testen, ob ein Layout am Workbench ist
C :
K : /LI L
K : #IF (Z_ERROR ne 0.0) then goto nolay
C :
C : **********************************************************************
C :
C : **** Layoutnamen bestimmen *****************
C : 
C : **** List auf die View 32 setzen, dann steht in z_list(1)=DRAWING oder 
ZEICHNUNG
C :      Dies wird Abbruchbedingung fuer folgende Schleifen
K : /LI V N 32
K : $
C : 
C : **** List Layout auf alle views
K : /LI L
C : **** Jetzt Suchschleife, um die erste View wieder zu finden
K : #anzahl=1
C :
K : #suchloop1:
C :
K :    #anzahl=anzahl+1.0
C :    **** Sicherheitsabbruch
K :    #if ( anzahl gt 100 ) then goto noview
K : #if ((Z_STR(anzahl) eq "DRAWING") OR (Z_STR(anzahl) eq "ZEICHNUNG")) then 
goto drwfound1
C :
K : #GOTO suchloop1
C :
K : #drwfound1:
C : **** Die View "DRAWING" oder "ZEICHNUNG" wurde wieder gefunden
C : **** auf z_str(anzahl-1) steht der Layoutname
C :
K : #drawing=Z_STR(anzahl-1)
C :
K : #output "Layoutname:  "drawing
C : ---------------------------------------------------------------------
C :
C : #output "********************************************"
C : #output "Ermitteln der Partnummer des Drafting Setups"
C : 
K : /MA MA 
K : FS ON 
K : F C QG I
K : drawing
K : Okay
K : ET 
K : $
K : F C Okay
K : FS OF 
K : Canc
C :
C : **** Pruefen, ob der Doppelklick notwendig ist
C :
K : #if (Z_LIST(1) eq 3) then goto nodopklick
C :
C : ----------------------------------------
C : **** Der Doppelklick ist notwendig
C : 
K : /MA MA 
K : FS ON 
K : F C QG I
K : drawing
K : Okay
K : ET 
K : dc 2
K : ET
K : $
K : F C Okay
K : FS OF 
K : Canc
C : ----------------------------------------
K : #nodopklick:
C : ----------------------------------------
C :
K : #anzahl=0
K : #partnr=" "
C :
K : #suchbenen:
C :
K :    #anzahl=anzahl+1
C :    **** Sicherheitsabbruch
K :    #if ( anzahl gt 100 ) then goto nonum
K :    #if ((Z_STR(anzahl) eq "DRAFTING SETUP") AND (Z_STR(anzahl+2) eq "---- 
")) then goto ende1
K :    #if ((Z_STR(anzahl) eq "DRAFTING SETUP") AND (Z_STR(anzahl+3) eq "---- 
")) then goto ende2
C :    **** Suche beenden, wenn die "DRAWING" (Schleife vorher) entdeckt wurde
K : #if ((Z_STR(anzahl) eq "DRAWING") OR (Z_STR(anzahl) eq "ZEICHNUNG")) then 
goto ende1
K : #GOTO suchbenen
C :
K : #ende1:
K : #partnr=" "
K : #GOTO weiter1
C :
K : #ende2:
K : #partnr=Z_STR(anzahl+1)
C : ---------------------------------------------------------------------
C :
K : #weiter1:
K : #output "Partnummer:  "partnr
C :
C : **** ENDE Ermittlung Partnummer ****
C : ---------------------------------------------------------------------
C : **** Reportfile generieren      ****
C :
K : #output " **** Reportfile erzeugen ****"
C : Reportfile loeschen
K : #EXECUTE "\rm -rf    ./idminfo.3d2d"
C :-----------------------------------------------------
C :
C : Item - Reportfile "idminfo.3d2d" aus IDM loeschen
C :
K : $ mpos :
C :  Filter setzen -> SC C Set Current, Current Project
K :  /MA IT SC C FLT
K :  C
K :  QG I idminfo
K :  ! QG T
K :  TA DC 20;
K :  TA 24;
K :  MR
K : OKAY
K : OKAY
K :  IS 1;
K : #IF ( Z_ERROR ne 0.0 ) then goto notloesche
K : ACT D
K : Y
C :
K : #notloesche:
K : CANC
K : $ return
C :
C :-----------------------------------------------------
C : Reportformat setzen
C :
C : IDM-Name      Attribut     Width           Alignment
C : ---------------------------------------------------
C : Project_name, Name       , 32 characters , left
C : Layout_name , Name       , 32 characters , left
C : Part #      , Part Number, 32 characters , left
C : Version     , Ver        ,  3 characters , left
C : Revision    , Rev        ,  3 characters , left
C : Item-Typ    , Type       , 15 characters , left
C :
K : $ mpos :
C : Filter setzen -> SC C Set Current, Current Project
K : /MA IT SC C
K :  RE
K :  F
K :  RA
C : 
C :  Page settings definieren
K :  P
K :  PW 132
K :  LM 5
K :  RM 0
K :  S 3
K :  LP 60
K : OKAY
C : 
C :  Attribute selektieren und Format definieren
C : 
C : 1. Projectname
K :  AS
K :  A 1;
K : OKAY
K :  A DC 1;
C :
C :  A 10;
C : OKAY
C :  C Projectname
C :  W 32
C :  AL L
C :  SUM N
C :  ADD
C : 
C : 2. Layoutname
C :  AS
K :  A 2;
K : OKAY
K :  C Layoutname
K :  W 32
K :  AL L
K :  SUM N
K :  ADD
C : 
C : 2. Partnumber
K :  AS
K :  A 4;
K : OKAY
K :  C Part#
K :  W 32
K :  AL L
K :  SUM N
K :  ADD
C :
C : 3. Version
K :  AS
K :  A 5;
K : OKAY
K :  C Ver
K :  W 3
K :  AL L
K :  SUM N
K :  ADD
C :
C : 4. Revision
K :  AS
K :  A 6;
K : OKAY
K :  C Rev
K :  AL L
K :  SUM N
K :  ADD
C :
C : 5. Type
K :  AS
K :  A 3;
K : OKAY
K :  C Type
K :  W 15
K :  AL L
K :  SUM N
K :  ADD
C :
K : OKAY
K : CANC
K : CANC
K : $ return
C :-----------------------------------------------------
C : Item selektieren und mittels Report ausgeben
K : $ mpos :
K : /MA IT FLT
K :  C
K :  QG I drawing
K :  ! QG T
K :  TA 6;
K :  TA 6;
K :  TA 6;
K :  TA 6;
K :  TA DC 6;
K :  TA 9;
K :  MR
K : OKAY
K :  ! QG AS
K :  A 1;
K : OKAY
K :  ! QG VA partnr
K :  ! QG ADD
K : OKAY
K :  IS 1;
K :  RE
K :  P
K :  PT N
K :  FTO Y
K :  FN ./idminfo.3d2d
K :  FTY F
K : OKAY
K : Y
K : CANC
K : CANC
K : $ return
C :
K : #GOTO liste_ok
C :
C :-----------------------------------------------------
C : Beim Suchen konnte keine Partnummer gefunden werden
C :
K : #nonum:
C :
K : #output "***** Es wurde keine Partnummer ermittelt !!!!!!! *******"
C :
K : $ return
K : #GOTO liste_ok
C :
C :-----------------------------------------------------
K : #liste_ok:
C :
C : **** Alles zuruecksetzen
C : 
C : **** Filter zuruecksetzen
K : /MA GE FS OF Okay
C : 
C : **** Im Drafting Setup Visible setzen
K : /TA D
K : /MO AP VIS
K : $
C : 
K : #DELETE all
K : #GOTO ende
C :
C : -----------------------------------------------
C : Es ist kein Drafting Setup am Workbench
C :
K : #nolay:
C :
K : #output "********************************************************"
K : #output "***** Bitte laden Sie zuerst ein Drafting Setup ********"
C :
K : $ return
K : #DELETE all
K : #GOTO ende
C :
C : -----------------------------------------------
C : Beim Suchen der ersten View konnte diese nicht gefunden werden
C :
K : #noview:
C :
K : #output "********************************************************"
K : #output "***** Die erste View wurde nicht mehr gefunden ! *******"
C :
K : $ return
K : #DELETE all
K : #GOTO ende
C :
C : -----------------------------------------------
K : #ende:
K : $
C :
C : ---------------------------------------
C : **** Forms zuschalten
K : /O P P 2 D FD ON Okay Okay
C :
C : **** Fehlermeldung fuer COUNTS in Formblaettern zuschalten
C :
K : /O P P 8 ;
K : WA ON
K : Okay Okay
C : ---------------------------------------
K : #output "***** Ende Ermittlung Layoutinformationen **************"
K : #output "********************************************************"
K : #echo all
C :
E : **** END OF SESSION **** 

