// AQL Include-Datei zum Erzeugen von EUKLID-EDX Dateien
//
var BLNK
var C0
var SET_PSI
var INTERSEC
var I_DAT
var DimTextHeight
var TextHeight
var EDXFILENAME

// Globale Listen fuer die Gruppierung

InsideContour   = false
ContourTypeList = { }        // Group with the elementtypes inside Contour
LastPoint       = { }
NrOfContourElem = 0          // Only Count elements inside a Contour
InsideGroup     = false
GroupList       = { }        // Group with the elements inside the Group
NrOfGroupElem   = 0          // Only Count elements inside a group
GroupFilelist   = { }
GroupHierarchieList = { }
GroupColorList  = { }        // used to store groupcolors
InsertFilelist  = { }

// Fehlerverfolgung (Implementierung)
CountLayers             = 0
CountSubLayers          = 0
CountEllipses           = 0
CountEllipseArcs        = 0
CountTextAbsolute       = 0
CountTextAnglePos       = 0
CountTextBlocks         = 0
CountContourOfElements  = 0
CountContourUnions      = 0
CountSymbolComments     = 0
CountSymbolForms        = 0
CountRadiusDimensions   = 0
CountLinearDimensions   = 0
CountDiameterDimensions = 0
CountAngularDimensions  = 0
CountSplines            = 0
CountGroups             = 0
CountSternXGroups       = 0
CountSternDGroups       = 0
CountSternUGroups       = 0
CountPlanes             = 0
CountPlanesOfContour    = 0
GroupRecurseCount       = 0
LastRecurseCount        = 0
ContourinContourCount   = 0
LastContourElement      = 0

ObdVersion  = 5            // Standard >= Version 5
OBD_CLASSIC = 4
DTInfoType  = 0            // unknown
NewSubLayerGroup = { }
SomethingWritten = false

function DTCreateLengthAbsolute ( length, lengthname ) forward
function DTSetInVisible         ( ele )                forward
function DTCreateSubLayer       ( name, parent, status, blanked, colnumber ) forward

/* ====================================================================== */
/* Intern aufgerufene Funktionen                                          */
/* ====================================================================== */

function CloseLastElem ()
    if SomethingWritten = true then
       if (InsideGroup   = true and NrOfGroupElem   = 0) or
          (InsideContour = true and NrOfContourElem = 0) then
          // dont write anything
       else
          `,` nl
       end
    else
        //nl
        SomethingWritten = true
    end
end

function ComparePoints ( p1, p2 )
    ret = false
    lp1 = len (p1)
    lp2 = len (p2)
    if (lp1 = lp2 and (lp1 = 2 or lp1 = 3)) then
       if p1.el_1 = p2.el_1 and p1.el_2 = p2.el_2 then
          if lp1 = 3 then
             if lp1.el_3 = lp2.el_3 then
                ret = true
             end
          else
             ret = true
          end
       end
    end
    return (ret)
end

function WriteEDXPoint ( pos )
    xp = pos.el_1
    yp = pos.el_2
    zp = pos.el_3
    `.(` [xp] `,` [yp] `,` [zp] `)`
end

function WriteEDXVector ( vec )
    xv = vec.el_1
    yv = vec.el_2
    zv = vec.el_3
    `'(` [xv] `,` [yv] `,` [zv] `)`
end

function CreateLineVector (ap, ep)
   lvx = ep.el_1 - ap.el_1
   lvy = ep.el_2 - ap.el_2
   lvz = ep.el_3 - ap.el_3
   return ({lvx,lvy,lvz})
end

function CreateLineALVector (angle, length)
   lvx = cos(angle) * length
   lvy = sin(angle) * length
   lvz = 0.0
   return ({lvx,lvy,lvz})
end

function CheckGroupName (GroupName)
   NewName = ""
   StartChar = substr (GroupName, 1, 1)
   if StartChar = "*" then
      if GroupName = "*X" then
         CountSternXGroups = CountSternXGroups + 1
         NewName = "X" + string (CountSternXGroups)
      else
         if GroupName = "*U" then
            CountSternUGroups = CountSternUGroups + 1
            NewName = "U" + string (CountSternUGroups)
         else
            if GroupName = "*D" then
               CountSternDGroups = CountSternDGroups + 1
               NewName = "D" + string (CountSternDGroups)
            else
               // remove only the *
               NamLength = len (GroupName)
               NewName = substr (GroupName, 1, NamLength - 1)
               //break()
            end
         end
      end
   else
      NewName = GroupName
   end
   return (NewName)
end

/* ====================================================================== */
/* Funktionen, die vom Datatranslator in die AQL-Datei eingetragen werden */
/* ====================================================================== */

function show_status_percent (percent)
   /* nothing to do */
end

function DTSetInVisible ( ele )
    move_set_to_layer(ele,BLNK)
end

/* ====================================================================== */

function DTSetOBDVersion ( version )
    ObdVersion = version
end

/* ====================================================================== */
function DTSetWorld ( world )
    return (world)
end

/* ====================================================================== */
function DTGetWorld ( )
/*
    if ObdVersion > OBD_CLASSIC then
        if empty (aql_argument_list) then
            first_worlds = top.list_world where .name="first_world"
            world = first_worlds.first
        else
            world = top.["el_"+aql_arg_1]
        end
    else
        if empty (aql_argument_list) then
            world = top.list_world.first
        else
            world=top.["el_"+aql_arg_1]
        end
    end
    return (world)
*/
    return ({0.0,0.0,0.0})
end

/* ====================================================================== */
function DTSetSessionDefaults ()
    prompt (" \n")
    if valid(EDXFILENAME) then
       file EDXFILENAME output
    else
       EDXFILENAME="tmp.edx"
       file "tmp.edx" output
    end
    GroupFilelist = { EDXFILENAME }
end

function DTWriteGroupHierarchy (Father, SonGroup)
   Count = 1
   for Group in SonGroup do
      if Count > 1 then `,` nl end
      if len (Group) > 1 then           // Group in last group
         // get the color of the group
         GroupColor = GroupColorList where .el_1 = Group
         if valid (GroupColor) then
            Color = GroupColor.el_1.el_2
         else
            Color = 14
         end
         if not valid (Color) then Color = 14 end
         `{"` [Group] `","` [Father] `","` [Color] `"}`
      else
         DTWriteGroupHierarchy (LastGroup, Group)
      end
      Count = Count + 1
      LastGroup = Group
   end
end

/* ====================================================================== */
function DTRestoreSystemDefaults ()
    // Also write Group Hierarchie List
    LastGroup = "Main"
    Count = 1
    if len (GroupHierarchieList) > 0 then    // Groups inside
       CloseLastElem ()
       `3:{0:"ELSgroup",`                    // Start Group
/*
       for Group in GroupHierarchieList do
           if Count > 1 then `,` nl end
           if len (Group) > 1 then           // Group in last group
              `{"` [Group] `","` [LastGroup] `",14}`
           else
               [Group] nl
           end
           Count = Count + 1
       end
*/
       DTWriteGroupHierarchy (LastGroup, GroupHierarchieList)
       `}` nl
    end

    file <screen> error_output
    nl
    file <screen> output
    nl `Close file ` [EDXFILENAME] nl
end

/* ====================================================================== */
function DTCreateLengthAbsolute ( length, lengthname )
    labs = abs (length)
    return (labs)
end

/* ====================================================================== */
function DTCreateLengthSum ( length1, length2, lengthname )
    lsum = lenght1 + length2
    return (lsum)
end

/* ====================================================================== */
function DTCreateLengthProd ( number, length, lengthname )
    lprod = length * number
    return (lprod)
end

/* ====================================================================== */

function DTCreateAngleAbsolute ( angle, anglename )
    angleabs = abs (angle)
    return (angleabs)
end

/* ====================================================================== */

function DTCreateAngleSum ( angle1, angle2, anglename )
    anglesum = angle1 + angle2
    return (anglesum)
end

/* ====================================================================== */

function DTCreateWorldFirstRota ( point, angle, scale )
    wx = point.el_1
    wy = point.el_2
    wz = point.el_3
    wa = angle
    ws = scale
    return ({wx,wy,wz,wa,{ws}})
end

/* ====================================================================== */

function DTCreateWorldRotaScale ( point, angle, xscale, yscale, deleted )
    wx  = point.el_1
    wy  = point.el_2
    wz  = point.el_3
    wa  = angle
    wsx = xscale
    wsy = yscale
    wsz = 1.0
    return ({wx,wy,wz,wa,{wsx,wsy,wsz}})
end

/* ====================================================================== */

function DTCreateLayer ( name, status, colnumber )
    /* No Layer available ??? */
    CountLayers = CountLayers + 1
    if CountLayers = 1 then prompt ("NOT IMPLEMENTED : DTCreateLayer\n") end
    return (invalid)
end

/* ====================================================================== */

function DTCreateSubLayer ( name, parent, status, blanked, colnumber )
    /* No Sublayer available ??? */
    CountSubLayers = CountSubLayers + 1
    if CountSubLayers = 1 then prompt ("NOT IMPLEMENTED : DTCreateSubLayer\n") end
    return (invalid)
end

/* ====================================================================== */

function DTSetLayerStatusInViewports (LayerGroup, ListType)
    /* No Layer -> No Layerstatus ???? */
    prompt ("NOT IMPLEMENTED : DTSetLayerStatusInViewports\n")
end

/* ====================================================================== */

function DTSetLayerStatus (LayerGroup)
   /* No Layer -> no Status ???? */
    prompt ("NOT IMPLEMENTED : DTSetLayerStatus\n")
end

/* ====================================================================== */
function DTCreatePointOrigin ( world, pointname )
    xp = world.el_1
    yp = world.el_2
    zp = world.el_3
/* Don't write Points
    CloseLastElem ()
    `{`
    WriteEDXPoint ({xp,yp,zp})
    `}`
*/
    return ({xp,yp,zp})
end

/* ====================================================================== */
function DTCreatePointRelative ( refpoint, x, y, blanked, colnumber, infogroup )
    xp = refpoint.el_1 + x
    yp = refpoint.el_2 + y
    zp = 0.0
/* Don't write Points
    CloseLastElem ()
    `{`
    WriteEDXPoint ({xp,yp,zp})
    `}`
*/
    return ({xp,yp,zp})
end

/* ====================================================================== */
function DTCreatePointSameX ( refpoint, y, blanked, colnumber, infogroup )
    xp = refpoint.el_1
    yp = refpoint.el_2 + y
    zp = 0.0
/* Don't write Points
    CloseLastElem ()
    `{`
    WriteEDXPoint ({xp,yp,zp})
    `}`
*/
    return ({xp,yp,zp})
end

/* ====================================================================== */
function DTCreatePointSameY ( refpoint, x, blanked, colnumber, infogroup )
    xp = refpoint.el_1 + x
    yp = refpoint.el_2
    zp = 0.0
/* Don't write Points
    CloseLastElem ()
    `{`
    WriteEDXPoint ({xp,yp,zp})
    `}`
*/
    return ({xp,yp,zp})
end

/* ====================================================================== */
function DTCreateLine ( z, linestylegroup, ap, ep, blanked, colnumber, infogroup )

    CloseLastElem ()

    if InsideGroup then NrOfGroupElem = NrOfGroupElem + 1 end  // Count group elements

    if InsideContour = true then
       if (NrOfContourElem = 0) then
          `0:`
       end
       // Write Line inside a CSEG
       EndPoint = 2
       PEqual = ComparePoints (ap, LastPoint)
       if PEqual = false then
          PEqual = ComparePoints (ep, LastPoint)
          if  PEqual = false then
             if LastContourElement = 19 then
                // here is something to do, maybe 
                // only if arcs have the wrong direction
                //break()
                //WriteEDXPoint (pa)
                //`,` nl               // CloseLastElem ()
             else
                 WriteEDXPoint (ap)
                 `,` nl          // CloseLastElem ()
             end
          else
             EndPoint = 1
          end
       end
       if EndPoint = 2 then
           WriteEDXPoint (ep)
           LastPoint = ep
       else
           WriteEDXPoint (ap)
           LastPoint = ap
       end
       ContourTypeList = ContourTypeList + "1"
       NrOfContourElem = NrOfContourElem + 1
       LastContourElement = 1
    else
       // now we write a single CSEG (consists from one Line)
    
       `{0:UT1024,{0:`
       WriteEDXPoint (ap)
       CloseLastElem ()
       WriteEDXPoint (ep)
       `}, {1}}`               // CSEG with 1 Lines
    end
    return ({{ap},{ep}})
end

/* ====================================================================== */
function DTCreateLineAngleLength ( z, linestylegroup, ap, angle, length, blanked, colnumber, infogroup )
    CloseLastElem ()
    `{.L(`
    WriteEDXPoint (ap)
    `,`
    vec = CreateLineALVector (angle, length)
    WriteEDXVector (vec)
    `)}`
    return ({{ap},{ep}})
end

/* ====================================================================== */
function DTCreateEndlessLineAngle ( z, linestylegroup, ap, angle, blanked, colnumber, infogroup )
    CloseLastElem ()
    `{.L(`
    WriteEDXPoint (ap)
    `,`
    vec = CreateLineALVector (angle, 5000)
    WriteEDXVector (vec)
    `)}`
    return ({{ap},{ep}})
end

/* ====================================================================== */
function DTCreateArc ( z, linestylegroup, axes, p1, p2, p3, blanked, colnumber, infogroup )
    CloseLastElem ()
    `{0:UT1024,{0:`
    WriteEDXPoint (p1)
    CloseLastElem ()
    WriteEDXPoint (p2)
    CloseLastElem ()
    WriteEDXPoint (p3)
    `}, {1,1}}`        // CSEG with 2 Lines

    prompt ("PROBLEM DETECTED : wrong arc Definition -> DTCreateArc\n")
    return ( invalid )
end

/* ====================================================================== */
function DTCreateArcCenter ( z, linestylegroup, axes, pa, pm, pe, radius, blanked, colnumber, infogroup )

    CloseLastElem ()

    if InsideGroup then NrOfGroupElem = NrOfGroupElem + 1 end  // Count group elements

    if InsideContour = true then
       if (NrOfContourElem = 0) then
          `0:`
          LastPoint = { 0, 0, 0 }
       end
       // Write Arc inside a CSEG
       EndPoint = 2
       PEqual = ComparePoints (pa, LastPoint)
       if PEqual = false then
          PEqual = ComparePoints (pe, LastPoint)
          if  PEqual = false then
             if LastContourElement = 19 then
                // here is something to do, maybe 
                // only if arcs have the wrong direction
                //break()
                //WriteEDXPoint (pa)
                //`,` nl               // CloseLastElem ()
             else
                WriteEDXPoint (pa)
                `,` nl               // CloseLastElem ()
             end
          else
             EndPoint = 1
          end
       end
       WriteEDXPoint (pm)
       `,` nl               //CloseLastElem ()
       if EndPoint = 2 then
          WriteEDXVector ({0,0,-radius})
          `,` nl               //CloseLastElem ()
          WriteEDXPoint (pe)
          LastPoint = pe
       else
          WriteEDXVector ({0,0,radius})
          `,` nl               //CloseLastElem ()
          WriteEDXPoint (pa)
          LastPoint = pa
       end
       ContourTypeList = ContourTypeList + "19"
       NrOfContourElem = NrOfContourElem + 1
       LastContourElement = 19
    else
       `{0:UT1024,{0:`
       WriteEDXPoint (pa)
       CloseLastElem ()
       WriteEDXPoint (pm)
       CloseLastElem ()
       WriteEDXVector ({0,0,-radius})
       CloseLastElem ()
       WriteEDXPoint (pe)
       `}, {19}}`           // CSEG with 1 arc
    end
    return ( invalid )
end

/* ====================================================================== */
function DTCreateCircle ( z, linestylegroup, axes, mp, radius, blanked, colnumber, infogroup )
    if InsideContour = true then
       // inside a contour no circle is possible,
       // we write now an arc
       pax = mp.el_1 - radius
       pay = mp.el_2

       DTCreateArcCenter ( z, linestylegroup, axes, { pax pay mp.el_3 }, mp, { pax pay mp.el_3 }, radius, blanked, colnumber, infogroup )
    else
       CloseLastElem ()
       `{.C(`
       WriteEDXPoint (mp)
       `,'(,,`
       [radius]
       `))}`
    end
    return ({mp,radius})
end

/* ====================================================================== */
function DTCreateEllipse ( z, linestylegroup, axes, mp, pax1, pax2, blanked, colnumber, infogroup )
    CountEllipses = CountEllipses + 1
    if CountEllipses = 1 then prompt ("NOT IMPLEMENTED : DTCreateEllipse\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateEllipseArc ( z, linestylegroup, axes, pm, pax1, pax2, pa, pe, blanked, colnumber, infogroup )
    CountEllipseArcs = CountEllipseArcs + 1
    if CountEllipseArcs = 1 then prompt ("NOT IMPLEMENTED : DTCreateEllipseArc\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateTextAbsolute ( font, italic, prop, mirror, textpos, text, ap, height, length, blanked, colnumber, infogroup )
    CountTextAbsolute = CountTextAbsolute + 1
    if CountTextAbsolute = 1 then prompt ("NOT IMPLEMENTED : DTCreateTextAbsolute\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateTextAnglepos ( font, italic, prop, mirror, textpos, text, ap, height, angle, length, blanked, colnumber, infogroup )
    CountTextAnglePos = CountTextAnglePos + 1
    if CountTextAnglePos = 1 then prompt ("NOT IMPLEMENTED : DTCreateTextAnglePos\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateTextBlock ( font, italic, prop, mirror, textpos, textgroup, ap, height, angle, length, blanked, colnumber, infogroup )
    CountTextBlocks = CountTextBlocks + 1
    if CountTextBlocks = 1 then prompt ("NOT IMPLEMENTED : DTCreateTextBlock\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateContourOfElements ( z, elemgroup, blanked, colnumber, infogroup )
    if InsideContour = true then
       Meld = "Number of Elements in Contour : " + string(NrOfContourElem) + "\n"
       prompt (Meld)
       //if (NrOfContourElem = 0) then
       //   break()
       //end
       i = 0
       `},`
       // now write the Typelist
       nl `{`
       for EleType in ContourTypeList do
          i = i + 1
          if i > 1 then `,` end
          if i = 30 then
            nl
            i = 1
          end
          [EleType]
       end
       `}}`
       InsideContour = false
       ContourinContourCount = ContourinContourCount - 1
       LastContourElement = 0
    end
    return (NrOfContourElem)
end

/* ====================================================================== */
function DTStartContour ( )
 //break()
   ContourinContourCount = ContourinContourCount + 1
   if (ContourinContourCount = 1) then
      CloseLastElem ()
      InsideContour   = true
      ContourTypeList = {}          // Reset Typelist
      NrOfContourElem = 0
      `{0:UT1024,{`                 // Start CSEG
   else
    //nl `nested contour (` [ContourinContourCount] `)`
    //break()
      // finish last Contour
      DTCreateContourOfElements ( 0, {}, 0, {0}, {} )
      ContourinContourCount = 0 //ContourinContourCount - 1
      // Start new Contour
      DTStartContour ()
   end
end

/* ====================================================================== */
function DTCreateContourUnion ( z, contgroup, blanked, colnumber, infogroup )
    CountContourUnions = CountContourUnions + 1
    if CountContourUnions = 1 then prompt ("NOT IMPLEMENTED : DTCreateContourUnion\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateSymbolComment ( font, italic, prop, height, arrowtype, textangle, text, start, sel, bend, end, txpos, blanked, colnumber, infogroup )
    CountSymbolComments = CountSymbolComments + 1
    if CountSymbolComments = 1 then prompt ("NOT IMPLEMENTED : DTCreateSymbolComment\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateSymbolForm ( font, italic, prop, height, symbol, toleranz, relationtextgroup, start, bend, frame, blanked, colnumber, infogroup )
    CountSymbolForms = CountSymbolForms + 1
    if CountSymbolForms = 1 then prompt ("NOT IMPLEMENTED : DTCreateSymbolForm\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateRadiusDimension ( control_set, textgroup, tolgroup, pos, shortlong, arrowgroup, circle, blanked, colnumber, infogroup )
    CountRadiusDimensions = CountRadiusDimensions + 1
    if CountRadiusDimensions = 1 then prompt ("NOT IMPLEMENTED : DTCreateRadiusDimension\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateLinearDimension ( type, control_set, textgroup, tolgroup, pos, projection, arrowgroup, plc1, plc2, sel, blanked, colnumber, infogroup )
    CountLinearDimensions = CountLinearDimensions + 1
    if CountLinearDimensions = 1 then prompt ("NOT IMPLEMENTED : DTCreateLinearDimension\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateDiameterDimension ( control_set, textgroup, tolgroup, pos, lagewinkel, arrowgroup, pc1, blanked, colnumber, infogroup )
    CountDiameterDimensions = CountDiameterDimensions + 1
    if CountDiameterDimensions = 1 then prompt ("NOT IMPLEMENTED : DTCreateDiameterDimension\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateAngularDimension ( type, control_set, textgroup, tolgroup, pos, longshort, arrowgroup, plgroup, sel, blanked, colnumber, infogroup )
    CountAngularDimensions = CountAngularDimensions + 1
    if CountAngularDimensions = 1 then prompt ("NOT IMPLEMENTED : DTCreateAngularDimension\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreateSpline ( z, linestylegroup, art, grad, points, blanked, colnumber, infogroup )
    CountSplines = CountSplines + 1
    if CountSplines = 1 then prompt ("NOT IMPLEMENTED : DTCreateSpline\n") end
    return (invalid)
end

/* ====================================================================== */
function DTStartGroup ( Name, RefPosGroup )
   GroupRecurseCount = GroupRecurseCount + 1
   CloseLastElem ()
   InsideGroup   = true
   GroupList     = {}            // Reset Typelist
   NrOfGroupElem = 0
// NewName = CheckGroupName (Name)
// break()
   if (LastRecurseCount < GroupRecurseCount) then
      GroupHierarchieList = GroupHierarchieList + { Name }
   else
      GroupHierarchieList = GroupHierarchieList + Name
   end
   if GroupRecurseCount > 1 then
      Meld = "WARNING: Group " + Name
      Meld = Meld + " in Group, Recurselevel : " + string(GroupRecurseCount) + "\n"
      prompt (Meld)
      // write Group to extra file (EDXFILENAME is original filename)
      newfile  = Name + ".tmp"
      Meld = "Nested Group, switch to file " + newfile + "\n"
      prompt (Meld)
      GroupFilelist = newfile + GroupFilelist
      file newfile output
    //break()
   end
   `{0:"` [Name] `",{`           // Start Group with Name
end

/* ====================================================================== */
function DTEndGroup ( Name )
    // Write end of group

    `}}` nl
  //break()
    InsideGroup = false
    CountGroups = CountGroups + 1
    if GroupRecurseCount > 1 then
       AktFileName = GroupFilelist.first
       InsertFilelist = InsertFilelist + { AktFileName }
       Meld = "End of Group (" + Name + "), close file " + AktFileName + " !\n"
       prompt (Meld)
       GroupFilelist = GroupFilelist.tail
       oldfile = GroupFilelist.first
       Meld = "End of nested Group, switch back to file " + oldfile + "\n"
       prompt (Meld)
       file oldfile
    else
       // now we had to insert all written groupfiles
       for GFile in InsertFilelist do
          if valid(GFile) then 
             Meld = "Insert file " + GFile + " in file " + GroupFilelist.first + "\n"
             prompt (Meld)
           //ThingsToInsert = file_read ( GFile )  // Problems with long files
             file GFile input
             while ThingsToInsert = parse_line () do
                 [ThingsToInsert] nl
             end            
             close()
             // now delete this file and remove it from our list
             ok = system ( "del ", GFile )
             if ok != 0 then ok = system ( "rm ", GFile ) end
          end
       end
       InsertFilelist = { }
    end
    LastRecurseCount = GroupRecurseCount
    GroupRecurseCount = GroupRecurseCount - 1
    return (invalid)
end

/* ====================================================================== */
function DTCreateGroup ( name, elementgroup, blanked, colnumber, infogroup )

    // we only store the color in our group - color - list
    
    GroupColor = { name, colnumber.el_1 }
    GroupColorList = GroupColorList + { GroupColor }
    
    return (invalid)
end

/* ====================================================================== */
function DTCreatePlane ( z, fillstyle, elementgroup, dist, angle, blanked, colgroup, infogroup )
    CountPlanes = CountPlanes + 1
    if CountPlanes = 1 then prompt ("NOT IMPLEMENTED : DTCreatePlane\n") end
    return (invalid)
end

/* ====================================================================== */
function DTCreatePlaneOfContour ( z, fillstyle, ele_contour, dist, angle, blanked, colgroup, infogroup )
    CountPlanesOfContour = CountPlanesOfContour + 1
    if CountPlanesOfContour = 1 then prompt ("NOT IMPLEMENTED : DTCreatePlaneOfContour\n") end
    return (invalid)
end
